/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void OpenCB();
static void CopyCB();
static void PasteCB();
static void CopyByName();

static Widget text;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, field, label, fname, open, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clipbyname", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) ե̾Ϥƥץ󤹤ΰ */
    ac = 0;
    field = XmCreateRowColumn(panel, "field", al, ac);
    XtManageChild(field);
    /* "ե̾: */
    ac = 0;
    label = XmCreateLabel(field, "label", al, ac);
    XtManageChild(label);
    /* ΰ */
    ac = 0;
    fname = XmCreateTextField(field, "fname", al, ac);
    XtManageChild(fname);
    /* [ץ] */
    ac = 0;
    open = XmCreatePushButton(field, "open", al, ac);
    XtAddCallback(open, XmNactivateCallback, OpenCB, fname);
    XtManageChild(open);

    /* (2) եƤɽΰ */
    ac = 0;
    text = XmCreateScrolledText(panel, "text", al, ac);
    XtManageChild(text);

    /* (3) ΰ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);
    /* [ԡ] --> åץܡɤ˥ǡ򥳥ԡ */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);
    /* [ڡ] --> åץܡɤǡФ */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    XtVaSetValues(XtParent(text), XmNtopWidget, field,
                                  XmNbottomWidget, control, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [ץ] ܥΥХå */
static void OpenCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget textf = (Widget)client_data;
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];

    /* (5) Ϥ줿ե̾Ф */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* (6) եƤƥȤɽ */
    if ((fp = fopen(filename, "r")) != NULL) {  /* ե򥪡ץ */
        XmTextSetString(text, "");  /* äƥȤƤõ */
        while (fgets(buff, BUFSIZ, fp) != NULL)
            XmTextInsert(text, XmTextGetLastPosition(text), buff); /* ɲ */
        fclose(fp);
    }

    XtFree(filename);
}

/* (7) [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;

    /* Ŭ̾ǥѥɡȥ󥰤äƤ */
    label = XmStringCreateLocalized("_my_text");

    /* (8) ̾ԡ򳫻 */
    if (XmClipboardStartCopy(XtDisplay(text), XtWindow(text), label,
                             XtLastTimestampProcessed(XtDisplay(text)),
                             text, CopyByName, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        return;
    }
    /* (9) եޥå̾򥳥ԡ */
    if (XmClipboardCopy(XtDisplay(text), XtWindow(text), item_id, "STRING",
                        NULL, XmTextGetLastPosition(text) * 2,
                        private_id, &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        return;
    }
    /* (10) ̾ԡλ */
    if (XmClipboardEndCopy(XtDisplay(text), XtWindow(text), item_id)
                                                       != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        return;
    }
    private_id++;
    XmStringFree(label);
}

/* (11) åץܡɤΥǡ׵ᤵ줿Ȥ˸ƤӽФ */
static void CopyByName(w, data_id, private_id, reason)
    Widget w;
    int *data_id;
    int *private_id;
    int *reason;
{
    char *string;

    if (*reason == XmCR_CLIPBOARD_DATA_REQUEST) {
        /* (12) ƥȡåȤȤФ */
        string = XmTextGetString(text);
        /* (13) ºݤΥǡ򥳥ԡ */
        if (XmClipboardCopyByName(XtDisplay(text), XtWindow(text), *data_id,
                    string, strlen(string), *private_id) != ClipboardSuccess) {
            XBell(XtDisplay(text), 0);
            XtFree(string);
            return;
        }
        XtFree(string);
    }
    else { /* *reason == XmCR_CLIPBOARD_DATA_DELETE */
        /* (14) ׵᤬äȤν */
    }
}

/* (15) [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    char buff[BUFSIZ];
    unsigned long num_bytes;
    long private_id;
    int status;

    /* (16) ǡμФ򳫻 */
    if (XmClipboardStartRetrieve(XtDisplay(text), XtWindow(text),
              XtLastTimestampProcessed(XtDisplay(text))) != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        return;
    }

    /* (17) ƥȤƤ򥯥ꥢ */
    XmTextSetString(text, "");

    /* (18) ꥵȤ˥ǡФ */
    do {
        status = XmClipboardRetrieve(XtDisplay(text), XtWindow(text),
                       "STRING", buff, sizeof(buff), &num_bytes, &private_id);
        /* (19) ФǡƥȤɲ */
        if (status == ClipboardSuccess || status == ClipboardTruncate) {
            buff[num_bytes] = '\0';  /* Ǹ NULL դ */
            XmTextInsert(text, XmTextGetLastPosition(text), buff);
        }
    } while (status == ClipboardTruncate);

    if (status != ClipboardSuccess)
        XBell(XtDisplay(text), 0); /* Ԥȥ٥Ĥ餹 */

    /* (20) ǡμФλ */
    XmClipboardEndRetrieve(XtDisplay(text), XtWindow(text));
}
