/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

typedef struct {  /* (Res1) ꥽ͳǼ¤Τ */
    Boolean  input_by_mm;  /* Ϥñ: True => mm, False =>  */
    XmString mm_label;     /* "ߥ᡼ȥ" ñ̤Υ٥ʸ */
    XmString inch_label;   /* "" ñ̤Υ٥ʸ */
} CustomRec, *CustomPtr;

static XtResource res[] = {  /* (Res2) ꥽¤Τ */
  {"inputByMm", "InputByMm", XtRBoolean,
   sizeof(Boolean), XtOffsetOf(CustomRec, input_by_mm), XtRString, "True"},
  {"mmLabel", "MmLabel", XmRXmString,
   sizeof(XmString), XtOffsetOf(CustomRec, mm_label), XtRString, "mm"},
  {"inchLabel", "InchLabel", XmRXmString,
   sizeof(XmString), XtOffsetOf(CustomRec, inch_label), XtRString, "inch"},
};

static XrmOptionDescRec opt[] = {  /* (Opt1) ȼץ */
    {"-mm",   "*inputByMm", XrmoptionNoArg, "True"},  /* ñ̤ mm */
    {"-inch", "*inputByMm", XrmoptionNoArg, "False"}, /* ñ̤  */
};

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, label;
    Arg    al[20];
    int    ac;
    CustomRec data;  /* ꥽ͳǼ¤ΤѰ */

    XtSetLanguageProc(NULL, NULL, NULL);
                                /* (Opt2) ȼץȸĿϤ */
    ac = 0;                                            /*             */
    toplevel = XtAppInitialize(&app_context, "Inputunit", opt, XtNumber(opt),
                               &argc, argv, NULL, al, ac);
    /* (Res3) ꥽ͤμФ */
    XtGetApplicationResources(toplevel, &data, res, XtNumber(res), NULL, 0);

    ac = 0;
    XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);
    ac = 0;
    text = XmCreateTextField(panel, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    if (data.input_by_mm) {
        XtSetArg(al[ac], XmNlabelString, data.mm_label); ac++;
    } else {
        XtSetArg(al[ac], XmNlabelString, data.inch_label); ac++;
    }
    label = XmCreateLabel(panel, "label", al, ac);
    XtManageChild(label);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
