/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void SelectCB();
static void PasteCB();
static Boolean ConvertProc();
static void LoseProc();
static void DoneProc();
static void GetValueProc();

static Atom xa_locale;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, select, paste;
    Arg al[20];
    int ac;
    XTextProperty textprop;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Selection", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ƥΰ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* [ƥ] ܥ --> ͭ: 쥯ͭ */
    ac = 0;
    select = XmCreatePushButton(panel, "select", al, ac);
    XtAddCallback(select, XmNactivateCallback, SelectCB, text);
    XtManageChild(select);

    /* [ڡ] ܥ --> ׵: 쥯󡦥ǡ׵ */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);
    XtManageChild(paste);

    /* (1) ʬθĶʸɤĴ٤ */
    if (XmbTextListToTextProperty(XtDisplay(toplevel), "", 1,
                                  XTextStyle, &textprop) != Success) {
        fprintf(stderr, "Cannot get encoding info.\n");
        exit(1);
    }
    xa_locale = textprop.encoding;

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* ͭ: [ƥ] ܥΥХå */
static void SelectCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* 쥯ͭ (3ĤΥХåϿ) */
    if (XtOwnSelection(text, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(text)),
                       ConvertProc, LoseProc, DoneProc))
        /* ͭǤ顤ƥȤĴɽΤ餻 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* ͭ: 쥯νͭ򼺤äȤ˸ƤӽФ */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    /* 쥯νͭԤǤʤʤä顤Ĵɽ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* ׵: [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* (2) ʬθĶʸɤǥ쥯Υǡ׵ */
    XtGetSelectionValue(text, XA_PRIMARY, xa_locale, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* ͭ: 쥯Υǡ׵ᤵ줿Ȥ˸ƤӽФ */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    char *string;

    /* žǡѰդ֤ */
    if (*selection == XA_PRIMARY && *target == xa_locale) {
        string = XmTextGetString(w);   /* žΤϤ줿ƥ */
        /* (3) ʸɤפƤΤǡʬʸɤΤޤޤž */
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ǹ NULL ɲ */
        *type_ret = xa_locale;         /* ߤθĶʸɤž */
        *format_ret = 8;               /* ʸΥեޥåȤ 8 */
        return True;   /* žǡνȤ */
    }
    else
        return False;  /* ׵ᤵ줿쥯ȥפ㤦 */
}

/* ׵: 쥯ΥǡäȤ˸ƤӽФ */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* ǡμ˼ */
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    if (*selection == XA_PRIMARY && *type == xa_locale) {
        /* (4) ʸɤפƤΤǡäǡ
               ΤޤޥƥȡåȤ˥ڡ */
        XmTextSetString(w, (char *)val);
        XtFree((char *)val);
    }
    else
        XBell(XtDisplay(w), 0);  /* פ㤦ȥ٥ǼԤι */
}

/* ͭ: ׵ԤǡäǸƤӽФ */
static void DoneProc(w, selection, target)
    Widget w;
    Atom *selection;
    Atom *target;
{
    /* žɬפʤȤСǼ¹ */
    /* ΥХåϿȤϥץꥱ󤬥ǡ뤳 */
    /* ϿʤäϡXt ưŪ˥ǡ */
}
